#include <Windows.h>

//
// Memory Functions
//

void * __cdecl operator new(size_t Size)
{
	return HeapAlloc(GetProcessHeap(), 0, Size);
}

void __cdecl operator delete(void *Memory)
{
	HeapFree(GetProcessHeap(), 0, Memory);
}

extern "C" void * __cdecl malloc(size_t Size)
{
	return HeapAlloc(GetProcessHeap(), 0, Size); 
}

extern "C" void   __cdecl free(void *Memory)
{
	HeapFree(GetProcessHeap(), 0, Memory);
}

extern "C" void * __cdecl calloc(size_t NumOfElements, size_t SizeOfElements)
{
	size_t bytes = NumOfElements * SizeOfElements;

	void *ptr = malloc(bytes);

	if (ptr)
	{
		char *p = (char *) ptr;

		while (bytes--) *p++ = 0;
	}
	
	return ptr;
}

extern "C" void * __cdecl realloc(void *Memory, size_t NewSize)
{
	size_t Size = HeapSize(GetProcessHeap(), 0, Memory);

	char *src = (char *) Memory;
	char *dst = (char *) malloc(NewSize);

	if (dst)
	{
		for (size_t x = 0; x < Size; x++)
		{
			dst[x] = *(char *) src[x];
		}

		free(Memory);
	}

	return dst;
}